/***************************************************************************
 *   Copyright (C) 2004 by Petric Frank                                    *
 *   pfrank@gmx.de                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "add-function.h"
#include <sys/xattr.h>
#include <errno.h>
#include <iostream>



add_function::add_function ()
: ctl_function ()
{
}



bool add_function::execute (int &argc, char *argv[])
{
  if (argc < 3)
  {
    help ();
    
    return false;
  }

  // handle the add comment
  std::string comment;
  if (argc > 3)
  {
    comment = argv[3];

    // transmit to file
    // ... to be done ...
  }

  // do the check-in
  char buffer[4096];
  int size = lgetxattr (argv[2], "add", buffer, 4096);
  
  if (size != 0)
  {
    std::cerr << "Error adding file." << std::endl;

    if (size < 0)
    {
      int err = errno;
  
      std::cerr << "  Code : " << err << " (" << strerror (err) << ")" << std::endl;
    }
    else
      std::cout << "  " << buffer << std::endl;

    return false;
  }

  display_log (argv[2]);
  
  return true;
}



void add_function::help () const
{
  std::cerr << "Add the file given to repository." << std::endl
            << std::endl
	    << "Command:" << std::endl
	    << "  cvsfsctl add <path> [<checkin comment>]" << std::endl;
}
