/***************************************************************************
 *   Copyright (C) 2004 by Petric Frank                                    *
 *   pfrank@gmx.de                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "help-function.h"
#include <iostream>
#include "function-factory.h"



help_function::help_function ()
: ctl_function ()
{
}



bool help_function::execute (int &argc, char *argv[])
{
  function_factory factory;

  if (argc < 3)
  {
    help ();
    
    return true;
  }

  ctl_function *func = factory.generate (argv[2]);

  if (!func)
  {
    std::cerr << "'" << argv[2] << "' is not a valid command." << std::endl;

    return true;
  }

  func->help ();

  return true;
}



void help_function::help () const
{
  std::cerr << "Gives a help for a specific function." << std::endl
            << std::endl
	    << "Command:" << std::endl
	    << "  cvsfsctl help <function>" << std::endl;
}
