/***************************************************************************
 *   Copyright (C) 2004 by Petric Frank                                    *
 *   pfrank@gmx.de                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __CVS_COMMAND_TREE_H__
#define __CVS_COMMAND_TREE_H__

#include "cvs-command.h"
#include "directory.h"
#include "cvs-directory-entry.h"

// forward references
class cvs_directory_entry;



class cvs_command_tree : public cvs_command
{
  public:
    cvs_command_tree (cvs_directory_entry &, const std::string &);
    virtual ~cvs_command_tree ();

    virtual bool run (cvs_session &);

    time_t execution_start () const { return started_scan; }
    double execution_time () const { return scan_duration; }

  private:
    bool send_command (cvs_session &);
    virtual bool process_line (cvs_session &, const std::string &);

    void add_directory (const std::string &, cvs_directory_entry &);
    void add_file (const std::string &, const std::string &);
  
    std::string cvs_root;
    std::string cvs_project;
    std::string cvs_label;
    cvs_directory_entry & root_entry;
    cvs_directory_entry current_dir;
    std::string current_path;
    time_t started_scan;
    double scan_duration;
};



#endif
