/***************************************************************************
 *   Copyright (C) 2004 by Petric Frank                                    *
 *   pfrank@gmx.de                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "cvs-connection.h"

//#include "TMountParameters.h"


cvs_connection::cvs_connection (const std::string &server, int port, const std::string &root, const std::string &project)
: cvs_server (server), cvs_port (port), cvs_root (root), cvs_project (project)
{
//  if (fUser.length () == 0)
//    fUser = "anonymous";

  if (cvs_root.length () == 0)
    cvs_root = "/cvsroot";

  if ((cvs_project.length () == 0) || (cvs_project == "/"))
    cvs_project = ".";
}



cvs_connection::cvs_connection (const cvs_connection &clone)
: cvs_server (clone.cvs_server), cvs_port (clone.cvs_port),
  cvs_root (clone.cvs_root), cvs_project (clone.cvs_project)
{
}



cvs_connection::~cvs_connection ()
{
}
