/***************************************************************************
 *   Copyright (C) 2004 by Petric Frank                                    *
 *   pfrank@gmx.de                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __CVS_CONNECTION_H__
#define __CVS_CONNECTION_H__

#include <string>

// forwardx references
class cvs_command;



class cvs_connection
{
  public:
    cvs_connection (const std::string &, int, const std::string &, const std::string &);
    virtual ~cvs_connection ();

    virtual cvs_connection *clone () = 0;

    const std::string & cvsroot () const { return cvs_root; }
    const std::string & project () const { return cvs_project; }

    virtual bool test () = 0;

    virtual bool execute_command (cvs_command &) = 0;

  protected:
    cvs_connection (const cvs_connection &);

    std::string cvs_server;
    int cvs_port;
    std::string cvs_root;
    std::string cvs_project;
};



#endif
