/***************************************************************************
 *   Copyright (C) 2004 by Petric Frank                                    *
 *   pfrank@gmx.de                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "cvs-pserver-session.h"
#include <ios>
#include "connected-socket.h"
#include "cvs-pserver-streambuf.h"
//#include "system-log.h"



cvs_pserver_session::cvs_pserver_session (cvs_connection &conn, connected_socket *sock)
: cvs_session (conn), cvs_socket (sock),
  pserver_send (new cvs_pserver_streambuf (*sock)),
  pserver_recv (new cvs_pserver_streambuf (*sock)), messages (0)
{
}



cvs_pserver_session::~cvs_pserver_session ()
{
  delete cvs_socket;
}



bool cvs_pserver_session::read_line (std::string *response)
{
//  system_log *log = system_log::instance ();
  char item;
  
  *response = "";

  recv ().get (item);
  while ((recv ().gcount () == 1) &&
         (item != '\012') && (item != '\015'))
  {
    *response += (char) item;
    recv ().get (item);
  }

  // strip blancs at the end of the line
  while ((response->length () > 0) && (*(response->rbegin ()) == ' '))
    response->erase (response->length () - 1);

//  log->debug << "--> trimmed: " << *response << std::endl;

  return recv ().good ();
}



int cvs_pserver_session::read_raw (char *buf, int size)
{
  recv ().read (buf, size);

  return recv ().gcount ();
}
