/***************************************************************************
 *   Copyright (C) 2004 by Petric Frank                                    *
 *   pfrank@gmx.de                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __CVS_PSERVER_SESSION_H__
#define __CVS_PSERVER_SESSION_H__

#include "cvs-session.h"

// forwardx references
class connected_socket;
class cvs_connection;



class cvs_pserver_session : public cvs_session
{
  public:
    cvs_pserver_session (cvs_connection &, connected_socket *);
    virtual ~cvs_pserver_session ();

    virtual bool read_line (std::string *);
    virtual int read_raw (char *, int);

    virtual std::ostream & send () { return pserver_send; }
    virtual std::istream & recv () { return pserver_recv; }

  private:  
    connected_socket *cvs_socket;
    std::ostream pserver_send;
    std::istream pserver_recv;
    std::ofstream *messages;
};



#endif
