/***************************************************************************
 *   Copyright (C) 2004 by Petric Frank                                    *
 *   pfrank@gmx.de                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <unistd.h>
#include <sys/types.h>
#include "cvsfs-fuse.h"
#include "system-log.h"



int main(int argc, char *argv[])
{
  // init logging system
  system_log *log = system_log::instance ("cvsfs-fuse", system_log::Daemon);

  log->debug.disable ();	// disable debug logging
  
  log->info << "cvsfs-fuse version " << VERSION << " started ..." << std::endl;

  // establish base class instance
  cvsfs_fuse *cvsfs = new cvsfs_fuse ();

  // Set uid and gid to use.
  // I decide to use the uid/gid of the call of this program.
  // May be changed by command line option in later versions.
  cvsfs->set_uid (getuid ());
  cvsfs->set_gid (getgid ());

  cvsfs->run (argc, argv);

  // store internal tree structures to file - for next startup
  cvsfs->shutdown ();

  return 0;
}
